# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.form import Form
from swagger_server import util


class Submission(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, id: int=None, form: Form=None, fields: object=None):  # noqa: E501
        """Submission - a model defined in Swagger

        :param id: The id of this Submission.  # noqa: E501
        :type id: int
        :param form: The form of this Submission.  # noqa: E501
        :type form: int
        :param fields: The fields of this Submission.  # noqa: E501
        :type fields: object
        """
        self.swagger_types = {
            'id': int,
            'form': int,
            'fields': object
        }

        self.attribute_map = {
            'id': 'id',
            'form': 'form',
            'fields': 'fields'
        }

        self._id = id
        self._form = form
        self._fields = fields

    @classmethod
    def from_dict(cls, dikt) -> 'Submission':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Submission of this Submission.  # noqa: E501
        :rtype: Submission
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this Submission.


        :return: The id of this Submission.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this Submission.


        :param id: The id of this Submission.
        :type id: int
        """

        self._id = id

    @property
    def form(self) -> int:
        """Gets the form of this Submission.


        :return: The form of this Submission.
        :rtype: int
        """
        return self._form

    @form.setter
    def form(self, form: int):
        """Sets the form of this Submission.


        :param form: The form of this Submission.
        :type form: int
        """

        self._form = form

    @property
    def fields(self) -> object:
        """Gets the fields of this Submission.


        :return: The fields of this Submission.
        :rtype: object
        """
        return self._fields

    @fields.setter
    def fields(self, fields: object):
        """Sets the fields of this Submission.


        :param fields: The fields of this Submission.
        :type fields: object
        """

        self._fields = fields
